from select import select
import pandas as pd
import os
from django.conf import settings
from django.contrib.auth.decorators import login_required, permission_required
from datetime import datetime, timedelta

from file_manager .models import DataAnalysisQueue
from plotly.graph_objs import Histogram
from plotly.offline import plot
from django.shortcuts import render

import plotly.graph_objs as go


@ login_required
def view(request):

    if request.method == 'POST':

        # def MaxquantPlot(pk, comparison_type, run_1_pk, run_2_pk):
        run_1_pk, run_2_pk = int(request.POST.get('id_plot_run_1')), int(
            request.POST.get('id_plot_run_2'))
        peptide_1 = DataAnalysisQueue.objects.filter(pk=run_1_pk)[
            0].output_file_2
        peptide_2 = DataAnalysisQueue.objects.filter(pk=run_2_pk)[
            0].output_file_2

        filename1 = os.path.join(settings.MEDIA_ROOT, peptide_1.name)
        filename2 = os.path.join(settings.MEDIA_ROOT, peptide_2.name)

        imported_data_1 = pd.read_csv(filename1, sep='\t')
        imported_data_2 = pd.read_csv(filename2, sep='\t')
        df_only_1 = imported_data_1.loc[~imported_data_1['Sequence'].isin(
            imported_data_2['Sequence'])]
        df_only_2 = imported_data_2.loc[~imported_data_2['Sequence'].isin(
            imported_data_1['Sequence'])]
        plot_div = plot({"data":
                         [Histogram(x=imported_data_1.filter(
                             like='RT in min').iloc[:, 0],
                             name=f"All {len(imported_data_1.index)} "
                                  f"Peptides in {run_1_pk}"
                         ),
                             Histogram(x=imported_data_2.filter(
                                 like='RT in min').iloc[:, 0],
                             name=f"All {len(imported_data_2.index)} "
                                  f" Peptides in {run_2_pk}"
                         ),
                             Histogram(x=df_only_1.filter(
                                 like='RT in min').iloc[:, 0],
                             name=f"{len(df_only_1.index)} "
                                  f" Peptides only in {run_1_pk}",
                             visible='legendonly'
                         ),
                             Histogram(x=df_only_2.filter(
                                 like='RT in min').iloc[:, 0],
                             name=f"{len(df_only_2.index)} "
                                  f" Peptides only in {run_2_pk}",
                             visible='legendonly'),
                         ],

                         "layout":
                         go.Layout(width=1500,)},
                        output_type='div', show_link=False, link_text="",)

    else:
        plot_div = None

    args = {
        "plot_div": plot_div,
        "DataAnalysisQueue":
            DataAnalysisQueue.objects.filter(
                run_status=True,
                finish_time__gte=datetime.today()-timedelta(
                    days=90)).order_by('-pk'),
        "formdata": request.POST,
    }

    return render(request,
                  'filemanager/peptide_retention.html', args)
